/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.21 from the
 * contents of V4l.xs. Do not edit this file, edit V4l.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "V4l.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
#include <sys/mman.h>

#include <string.h>
#include <pthread.h>
#include <linux/videodev.h>

#define NEED_newCONSTSUB
#include "../gppport.h"

#ifndef pTHX_
#define pTHX_
#endif

#define XSRETURN_bool(bool) if (bool) XSRETURN_YES; else XSRETURN_NO;

#define VBI_BPF (2048*32)

typedef struct video_capability *Video__Capture__V4l__Capability;
typedef struct video_channel *Video__Capture__V4l__Channel;
typedef struct video_audio *Video__Capture__V4l__Audio;
typedef struct video_picture *Video__Capture__V4l__Picture;
typedef struct video_tuner *Video__Capture__V4l__Tuner;

static void
attach_struct (SV *sv, size_t bytes)
{
  void *ptr;

  sv = SvRV (sv);
  Newz (0, ptr, bytes, void*);

  sv_magic (sv, 0, '~', 0, bytes);
  mg_find(sv, '~')->mg_ptr = ptr;
}

static SV *
new_struct (SV *sv, size_t bytes, const char *pkg)
{
  SV *rv = newRV_noinc (sv);
  attach_struct (rv, bytes);
  return sv_bless (rv, gv_stashpv ((char *)pkg, TRUE));
}

static void *
old_struct (SV *sv, const char *name)
{
  /* TODO: check name */
  return mg_find (SvRV(sv), '~')->mg_ptr;
}

static int
framesize (unsigned int format, unsigned int pixels)
{
  if (format==VIDEO_PALETTE_RGB565)	return pixels*2;
  if (format==VIDEO_PALETTE_RGB24)	return pixels*3;
  if (format==VIDEO_PALETTE_RGB555)	return pixels*2;
  if (format==VIDEO_PALETTE_HI240)	return pixels*1;
  if (format==VIDEO_PALETTE_GREY)	return pixels*1;
  if (format==VIDEO_PALETTE_RGB32)	return pixels*4;
  if (format==VIDEO_PALETTE_UYVY)	return pixels*2;
  if (format==VIDEO_PALETTE_YUYV)	return pixels*2;
  /* everything below is very probably WRONG */
  if (format==VIDEO_PALETTE_YUV410P)	return pixels*2;
  if (format==VIDEO_PALETTE_YUV411)	return pixels*2;
  if (format==VIDEO_PALETTE_YUV411P)	return pixels*2;
  if (format==VIDEO_PALETTE_YUV420)	return pixels*3/2;
  if (format==VIDEO_PALETTE_YUV420P)	return pixels*3/2;
  if (format==VIDEO_PALETTE_YUV422)	return pixels*2;
  if (format==VIDEO_PALETTE_YUV422P)	return pixels*2;
  if (format==VIDEO_PALETTE_PLANAR)	return pixels*2;
  if (format==VIDEO_PALETTE_RAW)	return pixels*8;
  return 0;
}

struct private {
  int fd;
  unsigned char *mmap_base;
  struct video_mbuf vm;
};

static int
private_free (pTHX_ SV *obj, MAGIC *mg)
{
  struct private *p = (struct private *)mg->mg_ptr;
  munmap (p->mmap_base, p->vm.size);
  return 0;
}

static MGVTBL vtbl_private = {0, 0, 0, 0, private_free};

static struct private *
find_private (SV *sv)
{
  HV *hv = (HV*)SvRV(sv);
  MAGIC *mg = mg_find ((SV*)hv, '~');

  if (!mg)
    {
      struct private p;
      p.fd = SvIV (*hv_fetch (hv, "fd", 2, 0));
      if (ioctl (p.fd, VIDIOCGMBUF, &p.vm) == 0)
        {
          p.mmap_base = (unsigned char *)mmap (0, p.vm.size, PROT_READ|PROT_WRITE, MAP_SHARED, p.fd, 0);
          if (p.mmap_base)
            {
              sv_magic ((SV*)hv, 0, '~', (char*)&p, sizeof p);
              mg = mg_find ((SV*)hv, '~');
              mg->mg_virtual = &vtbl_private;
            }
        }
    }

  return (struct private *) (mg ? mg->mg_ptr : 0);
}

typedef unsigned char u8;
typedef unsigned int UI;

#define get_field(field) (*hv_fetch ((HV*)SvRV (self), #field, strlen(#field), 0))

/* only one thread currently */
typedef struct vbi_frame {
  struct vbi_frame *next;
  int size;
  char data[VBI_BPF];
} vbi_frame;
static vbi_frame *vbi_head, *vbi_tail,
                 *vbi_free;
static int vbi_fd;
static UI vbi_max;
static pthread_t vbi_snatcher;
static pthread_mutex_t vbi_lock = PTHREAD_MUTEX_INITIALIZER;
static pthread_cond_t vbi_cond = PTHREAD_COND_INITIALIZER;

static void *
vbi_snatcher_thread (void *arg)
{
  /* try to become a realtime process. */
#ifdef _POSIX_THREAD_PRIORITY_SCHEDULING
  {
    struct sched_param sp;

    sp.sched_priority = (sched_get_priority_max (SCHED_FIFO)
                         + sched_get_priority_min (SCHED_FIFO)) / 2 - 1;
    pthread_setschedparam (pthread_self (), SCHED_FIFO, &sp);
  }
#endif
  for(;;)
    {
      vbi_frame *next;

      pthread_mutex_lock (&vbi_lock);
      if (vbi_free)
        {
          next = vbi_free;
          vbi_free = vbi_free->next;
          pthread_mutex_unlock (&vbi_lock);

          next->next = 0;
          next->size = read (vbi_fd, next->data, VBI_BPF);

          pthread_mutex_lock (&vbi_lock);

          if (vbi_tail)
            vbi_tail->next = next;
          else
            vbi_head = vbi_tail = next;

          vbi_tail = next;
          vbi_max--;

          pthread_cond_signal (&vbi_cond);
          pthread_mutex_unlock (&vbi_lock);
        }
      else 
        {
          static struct timespec to = { 0, 1000000000 / 70 }; /* skip almost a frame */

          pthread_mutex_unlock (&vbi_lock);
          pthread_testcancel ();
          nanosleep (&to, 0);
        }
    }
}

#line 203 "V4l.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 255 "V4l.c"

XS(XS_Video__Capture__V4l__VBI_field); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__VBI_field)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0);
	SV *	RETVAL;
#line 201 "V4l.xs"
        int fd = SvIV(get_field(fd));

        if (vbi_fd == fd)
          {
            vbi_frame *next;

            pthread_mutex_lock (&vbi_lock);
            while (!vbi_head)
              pthread_cond_wait (&vbi_cond, &vbi_lock);

            RETVAL = newSVpvn (vbi_head->data, vbi_head->size);

            vbi_max++;
            next = vbi_head->next;

            vbi_head->next = vbi_free;
            vbi_free = vbi_head;

            vbi_head = next;

            if (!next)
              vbi_tail = vbi_head;

            pthread_mutex_unlock (&vbi_lock);
          }
        else
          {
            int len;

            RETVAL = newSVpvn ("", 0);
            SvGROW (RETVAL, VBI_BPF);
            len = read (fd, SvPV_nolen (RETVAL), VBI_BPF);
            SvCUR_set (RETVAL, len);
          }

#line 306 "V4l.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__VBI_backlog); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__VBI_backlog)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "self, backlog");
    {
	SV *	self = ST(0);
	unsigned int	backlog = (unsigned int)SvUV(ST(1));
#line 244 "V4l.xs"
{
        while (vbi_max != backlog)
          {
            vbi_frame *f;

            pthread_mutex_lock (&vbi_lock);

            if (vbi_max < backlog)
              {
                f = malloc (sizeof (vbi_frame));
                f->next = vbi_free;
                vbi_free = f;
                vbi_max++;
              }
            else
              {
                if (vbi_free)
                  {
                    f = vbi_free;
                    vbi_free = vbi_free->next;
                    free (f);
                    vbi_max--;
                  }
              }

            pthread_mutex_unlock (&vbi_lock);
          }

        if (backlog)
          {
            if (!vbi_fd)
              {
                vbi_fd = SvIV(get_field(fd));
                pthread_create (&vbi_snatcher, 0, vbi_snatcher_thread, 0);
              }
          }
        else
          {
            if (vbi_fd)
              {
                pthread_cancel (vbi_snatcher);
                pthread_join (vbi_snatcher, 0);
                vbi_fd = 0;
              }

            /* no locking necessary, in theory */
            while (vbi_head)
              {
                vbi_frame *next = vbi_head->next;

                free (vbi_head);
                vbi_head = next;
              }

            vbi_tail = 0;
          }
}
#line 385 "V4l.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Video__Capture__V4l__VBI_queued); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__VBI_queued)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	int	RETVAL;
	dXSTARG;
#line 305 "V4l.xs"
        if (vbi_fd)
          {
            /* FIXME: lock/unlock */
            pthread_mutex_lock (&vbi_lock);
            RETVAL = !!vbi_head;
            pthread_mutex_unlock (&vbi_lock);
          }
        else
          RETVAL = 1;
#line 414 "V4l.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l_capture); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l_capture)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "sv, frame, width, height, format = VIDEO_PALETTE_RGB24");
    {
	SV *	sv = ST(0);
	unsigned int	frame = (unsigned int)SvUV(ST(1));
	unsigned int	width = (unsigned int)SvUV(ST(2));
	unsigned int	height = (unsigned int)SvUV(ST(3));
	unsigned int	format;
	SV *	RETVAL;

	if (items < 5)
	    format = VIDEO_PALETTE_RGB24;
	else {
	    format = (unsigned int)SvUV(ST(4));
	}
#line 327 "V4l.xs"
{
        struct private *p;
        if ((p = find_private (sv)))
          {
            struct video_mmap vm;
            vm.frame  = frame;
            vm.height = height;
            vm.width  = width;
            vm.format = format;
            if (ioctl (p->fd, VIDIOCMCAPTURE, &vm) == 0)
              {
                SV *fr = newSV (0);
                SvUPGRADE (fr, SVt_PV);
                SvREADONLY_on (fr);
                SvPVX (fr) = p->mmap_base + p->vm.offsets[frame];
                SvCUR_set (fr, framesize (format, width*height));
                SvLEN_set (fr, 0);
                SvPOK_only (fr);
                RETVAL = fr;
              }
            else
              XSRETURN_EMPTY;
          }
        else
          XSRETURN_EMPTY;
}
#line 471 "V4l.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l_sync); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l_sync)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "sv, frame");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	sv = ST(0);
	int	frame = (int)SvIV(ST(1));
#line 361 "V4l.xs"
{
        struct private *p;
        if ((p = find_private (sv))
            && ioctl (p->fd, VIDIOCSYNC, &frame) == 0)
          XSRETURN_YES;
        else
          XSRETURN_EMPTY;
}
#line 503 "V4l.c"
	PUTBACK;
	return;
    }
}


XS(XS_Video__Capture__V4l__freq); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__freq)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "fd, fr");
    {
	int	fd = (int)SvIV(ST(0));
	unsigned long	fr = (unsigned long)SvUV(ST(1));
	unsigned long	RETVAL;
	dXSTARG;
#line 375 "V4l.xs"
        if (items > 1)
          {
            fr = ((fr<<4)+499)/1000;
            ioctl (fd, VIDIOCSFREQ, &fr);
          }
        if (GIMME_V != G_VOID)
          {
            if (ioctl (fd, VIDIOCGFREQ, &fr) == 0)
              RETVAL = (fr*1000+7)>>4;
            else
              XSRETURN_EMPTY;
          }
        else
          XSRETURN (0);
#line 540 "V4l.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__capabilities_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__capabilities_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0));
	SV *	RETVAL;
#line 397 "V4l.xs"
        RETVAL = new_struct (newSViv (fd), sizeof (struct video_capability), "Video::Capture::V4l::Capability");
#line 562 "V4l.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__channel_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__channel_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0));
	SV *	RETVAL;
#line 405 "V4l.xs"
        RETVAL = new_struct (newSViv (fd), sizeof (struct video_channel), "Video::Capture::V4l::Channel");
#line 585 "V4l.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__tuner_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__tuner_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0));
	SV *	RETVAL;
#line 413 "V4l.xs"
        RETVAL = new_struct (newSViv (fd), sizeof (struct video_tuner), "Video::Capture::V4l::Tuner");
#line 608 "V4l.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__audio_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__audio_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0));
	SV *	RETVAL;
#line 421 "V4l.xs"
        RETVAL = new_struct (newSViv (fd), sizeof (struct video_audio), "Video::Capture::V4l::Audio");
#line 631 "V4l.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__picture_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__picture_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0));
	SV *	RETVAL;
#line 429 "V4l.xs"
        RETVAL = new_struct (newSViv (fd), sizeof (struct video_picture), "Video::Capture::V4l::Picture");
#line 654 "V4l.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Capability_get); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Capability_get)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0);
#line 439 "V4l.xs"
        XSRETURN_bool (ioctl (SvIV (SvRV (sv)), VIDIOCGCAP, old_struct (sv, "Video::Capture::V4l::Capability")) == 0);
#line 676 "V4l.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Video__Capture__V4l__Channel_get); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Channel_get)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0);
#line 447 "V4l.xs"
        XSRETURN_bool (ioctl (SvIV (SvRV (sv)), VIDIOCGCHAN, old_struct (sv, "Video::Capture::V4l::Channel")) == 0);
#line 696 "V4l.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Video__Capture__V4l__Channel_set); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Channel_set)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0);
#line 453 "V4l.xs"
        XSRETURN_bool (ioctl (SvIV (SvRV (sv)), VIDIOCSCHAN, old_struct (sv, "Video::Capture::V4l::Channel")) == 0);
#line 716 "V4l.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Video__Capture__V4l__Tuner_get); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Tuner_get)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0);
#line 461 "V4l.xs"
        XSRETURN_bool (ioctl (SvIV (SvRV (sv)), VIDIOCGTUNER, old_struct (sv, "Video::Capture::V4l::Tuner")) == 0);
#line 736 "V4l.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Video__Capture__V4l__Tuner_set); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Tuner_set)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0);
#line 467 "V4l.xs"
        XSRETURN_bool (ioctl (SvIV (SvRV (sv)), VIDIOCSTUNER, old_struct (sv, "Video::Capture::V4l::Tuner")) == 0);
#line 756 "V4l.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Video__Capture__V4l__Audio_get); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Audio_get)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0);
#line 475 "V4l.xs"
        XSRETURN_bool (ioctl (SvIV (SvRV (sv)), VIDIOCGAUDIO, old_struct (sv, "Video::Capture::V4l::Audio")) == 0);
#line 776 "V4l.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Video__Capture__V4l__Audio_set); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Audio_set)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0);
#line 481 "V4l.xs"
        XSRETURN_bool (ioctl (SvIV (SvRV (sv)), VIDIOCSAUDIO, old_struct (sv, "Video::Capture::V4l::Audio")) == 0);
#line 796 "V4l.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Video__Capture__V4l__Picture_get); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Picture_get)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0);
#line 489 "V4l.xs"
        XSRETURN_bool (ioctl (SvIV (SvRV (sv)), VIDIOCGPICT, old_struct (sv, "Video::Capture::V4l::Picture")) == 0);
#line 816 "V4l.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Video__Capture__V4l__Picture_set); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Picture_set)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0);
#line 495 "V4l.xs"
        XSRETURN_bool (ioctl (SvIV (SvRV (sv)), VIDIOCSPICT, old_struct (sv, "Video::Capture::V4l::Picture")) == 0);
#line 836 "V4l.c"
    }
    XSRETURN_EMPTY;
}


/* INCLUDE:  Including './genacc |' from 'V4l.xs' */


XS(XS_Video__Capture__V4l__Capability_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Capability_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, name=0");
    {
	Video__Capture__V4l__Capability	s = old_struct (ST(0), "Video::Capture::V4l::Capability");
	char *	name;
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    name = 0;
	else {
	    name = (char *)SvPV_nolen(ST(1));
	}
#line 17 "././genacc |"
	if (items==1)
          { RETVAL = s->name; }
        else
          { croak ("attribute 'name' is readonly"); }
#line 871 "V4l.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Capability_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Capability_type)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, type=0");
    {
	Video__Capture__V4l__Capability	s = old_struct (ST(0), "Video::Capture::V4l::Capability");
	int	type;
	int	RETVAL;
	dXSTARG;

	if (items < 2)
	    type = 0;
	else {
	    type = (int)SvIV(ST(1));
	}
#line 29 "././genacc |"
	if (items==1)
          { RETVAL = s->type; }
        else
          { croak ("attribute 'type' is readonly"); }
#line 904 "V4l.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Capability_channels); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Capability_channels)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, channels=0");
    {
	Video__Capture__V4l__Capability	s = old_struct (ST(0), "Video::Capture::V4l::Capability");
	int	channels;
	int	RETVAL;
	dXSTARG;

	if (items < 2)
	    channels = 0;
	else {
	    channels = (int)SvIV(ST(1));
	}
#line 41 "././genacc |"
	if (items==1)
          { RETVAL = s->channels; }
        else
          { croak ("attribute 'channels' is readonly"); }
#line 937 "V4l.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Capability_audios); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Capability_audios)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, audios=0");
    {
	Video__Capture__V4l__Capability	s = old_struct (ST(0), "Video::Capture::V4l::Capability");
	int	audios;
	int	RETVAL;
	dXSTARG;

	if (items < 2)
	    audios = 0;
	else {
	    audios = (int)SvIV(ST(1));
	}
#line 53 "././genacc |"
	if (items==1)
          { RETVAL = s->audios; }
        else
          { croak ("attribute 'audios' is readonly"); }
#line 970 "V4l.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Capability_maxwidth); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Capability_maxwidth)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, maxwidth=0");
    {
	Video__Capture__V4l__Capability	s = old_struct (ST(0), "Video::Capture::V4l::Capability");
	int	maxwidth;
	int	RETVAL;
	dXSTARG;

	if (items < 2)
	    maxwidth = 0;
	else {
	    maxwidth = (int)SvIV(ST(1));
	}
#line 65 "././genacc |"
	if (items==1)
          { RETVAL = s->maxwidth; }
        else
          { croak ("attribute 'maxwidth' is readonly"); }
#line 1003 "V4l.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Capability_maxheight); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Capability_maxheight)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, maxheight=0");
    {
	Video__Capture__V4l__Capability	s = old_struct (ST(0), "Video::Capture::V4l::Capability");
	int	maxheight;
	int	RETVAL;
	dXSTARG;

	if (items < 2)
	    maxheight = 0;
	else {
	    maxheight = (int)SvIV(ST(1));
	}
#line 77 "././genacc |"
	if (items==1)
          { RETVAL = s->maxheight; }
        else
          { croak ("attribute 'maxheight' is readonly"); }
#line 1036 "V4l.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Capability_minwidth); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Capability_minwidth)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, minwidth=0");
    {
	Video__Capture__V4l__Capability	s = old_struct (ST(0), "Video::Capture::V4l::Capability");
	int	minwidth;
	int	RETVAL;
	dXSTARG;

	if (items < 2)
	    minwidth = 0;
	else {
	    minwidth = (int)SvIV(ST(1));
	}
#line 89 "././genacc |"
	if (items==1)
          { RETVAL = s->minwidth; }
        else
          { croak ("attribute 'minwidth' is readonly"); }
#line 1069 "V4l.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Capability_minheight); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Capability_minheight)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, minheight=0");
    {
	Video__Capture__V4l__Capability	s = old_struct (ST(0), "Video::Capture::V4l::Capability");
	int	minheight;
	int	RETVAL;
	dXSTARG;

	if (items < 2)
	    minheight = 0;
	else {
	    minheight = (int)SvIV(ST(1));
	}
#line 101 "././genacc |"
	if (items==1)
          { RETVAL = s->minheight; }
        else
          { croak ("attribute 'minheight' is readonly"); }
#line 1102 "V4l.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Channel_channel); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Channel_channel)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, channel=0");
    {
	Video__Capture__V4l__Channel	s = old_struct (ST(0), "Video::Capture::V4l::Channel");
	int	channel;
	int	RETVAL;
	dXSTARG;

	if (items < 2)
	    channel = 0;
	else {
	    channel = (int)SvIV(ST(1));
	}
#line 116 "././genacc |"
	if (items==1)
          { RETVAL = s->channel; }
        else
          { s->channel = channel; }
#line 1135 "V4l.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Channel_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Channel_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, name=0");
    {
	Video__Capture__V4l__Channel	s = old_struct (ST(0), "Video::Capture::V4l::Channel");
	char *	name;
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    name = 0;
	else {
	    name = (char *)SvPV_nolen(ST(1));
	}
#line 128 "././genacc |"
	if (items==1)
          { RETVAL = s->name; }
        else
          { croak ("attribute 'name' is readonly"); }
#line 1168 "V4l.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Channel_tuners); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Channel_tuners)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, tuners=0");
    {
	Video__Capture__V4l__Channel	s = old_struct (ST(0), "Video::Capture::V4l::Channel");
	int	tuners;
	int	RETVAL;
	dXSTARG;

	if (items < 2)
	    tuners = 0;
	else {
	    tuners = (int)SvIV(ST(1));
	}
#line 140 "././genacc |"
	if (items==1)
          { RETVAL = s->tuners; }
        else
          { croak ("attribute 'tuners' is readonly"); }
#line 1201 "V4l.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Channel_flags); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Channel_flags)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, flags=0");
    {
	Video__Capture__V4l__Channel	s = old_struct (ST(0), "Video::Capture::V4l::Channel");
	U32	flags;
	U32	RETVAL;
	dXSTARG;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(1));
	}
#line 152 "././genacc |"
	if (items==1)
          { RETVAL = s->flags; }
        else
          { croak ("attribute 'flags' is readonly"); }
#line 1234 "V4l.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Channel_type); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Channel_type)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, type=0");
    {
	Video__Capture__V4l__Channel	s = old_struct (ST(0), "Video::Capture::V4l::Channel");
	U16	type;
	U16	RETVAL;
	dXSTARG;

	if (items < 2)
	    type = 0;
	else {
	    type = (unsigned short)SvUV(ST(1));
	}
#line 164 "././genacc |"
	if (items==1)
          { RETVAL = s->type; }
        else
          { croak ("attribute 'type' is readonly"); }
#line 1267 "V4l.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Channel_norm); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Channel_norm)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, norm=0");
    {
	Video__Capture__V4l__Channel	s = old_struct (ST(0), "Video::Capture::V4l::Channel");
	U16	norm;
	U16	RETVAL;
	dXSTARG;

	if (items < 2)
	    norm = 0;
	else {
	    norm = (unsigned short)SvUV(ST(1));
	}
#line 176 "././genacc |"
	if (items==1)
          { RETVAL = s->norm; }
        else
          { s->norm = norm; }
#line 1300 "V4l.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Audio_audio); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Audio_audio)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, audio=0");
    {
	Video__Capture__V4l__Audio	s = old_struct (ST(0), "Video::Capture::V4l::Audio");
	int	audio;
	int	RETVAL;
	dXSTARG;

	if (items < 2)
	    audio = 0;
	else {
	    audio = (int)SvIV(ST(1));
	}
#line 191 "././genacc |"
	if (items==1)
          { RETVAL = s->audio; }
        else
          { s->audio = audio; }
#line 1333 "V4l.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Audio_volume); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Audio_volume)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, volume=0");
    {
	Video__Capture__V4l__Audio	s = old_struct (ST(0), "Video::Capture::V4l::Audio");
	U16	volume;
	U16	RETVAL;
	dXSTARG;

	if (items < 2)
	    volume = 0;
	else {
	    volume = (unsigned short)SvUV(ST(1));
	}
#line 203 "././genacc |"
	if (items==1)
          { RETVAL = s->volume; }
        else
          { s->volume = volume; }
#line 1366 "V4l.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Audio_bass); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Audio_bass)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, bass=0");
    {
	Video__Capture__V4l__Audio	s = old_struct (ST(0), "Video::Capture::V4l::Audio");
	U16	bass;
	U16	RETVAL;
	dXSTARG;

	if (items < 2)
	    bass = 0;
	else {
	    bass = (unsigned short)SvUV(ST(1));
	}
#line 215 "././genacc |"
	if (items==1)
          { RETVAL = s->bass; }
        else
          { s->bass = bass; }
#line 1399 "V4l.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Audio_treble); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Audio_treble)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, treble=0");
    {
	Video__Capture__V4l__Audio	s = old_struct (ST(0), "Video::Capture::V4l::Audio");
	U16	treble;
	U16	RETVAL;
	dXSTARG;

	if (items < 2)
	    treble = 0;
	else {
	    treble = (unsigned short)SvUV(ST(1));
	}
#line 227 "././genacc |"
	if (items==1)
          { RETVAL = s->treble; }
        else
          { s->treble = treble; }
#line 1432 "V4l.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Audio_flags); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Audio_flags)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, flags=0");
    {
	Video__Capture__V4l__Audio	s = old_struct (ST(0), "Video::Capture::V4l::Audio");
	U32	flags;
	U32	RETVAL;
	dXSTARG;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(1));
	}
#line 239 "././genacc |"
	if (items==1)
          { RETVAL = s->flags; }
        else
          { s->flags = flags; }
#line 1465 "V4l.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Audio_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Audio_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, name=0");
    {
	Video__Capture__V4l__Audio	s = old_struct (ST(0), "Video::Capture::V4l::Audio");
	char *	name;
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    name = 0;
	else {
	    name = (char *)SvPV_nolen(ST(1));
	}
#line 251 "././genacc |"
	if (items==1)
          { RETVAL = s->name; }
        else
          { croak ("attribute 'name' is readonly"); }
#line 1498 "V4l.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Audio_mode); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Audio_mode)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, mode=0");
    {
	Video__Capture__V4l__Audio	s = old_struct (ST(0), "Video::Capture::V4l::Audio");
	U16	mode;
	U16	RETVAL;
	dXSTARG;

	if (items < 2)
	    mode = 0;
	else {
	    mode = (unsigned short)SvUV(ST(1));
	}
#line 263 "././genacc |"
	if (items==1)
          { RETVAL = s->mode; }
        else
          { s->mode = mode; }
#line 1531 "V4l.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Audio_balance); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Audio_balance)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, balance=0");
    {
	Video__Capture__V4l__Audio	s = old_struct (ST(0), "Video::Capture::V4l::Audio");
	U16	balance;
	U16	RETVAL;
	dXSTARG;

	if (items < 2)
	    balance = 0;
	else {
	    balance = (unsigned short)SvUV(ST(1));
	}
#line 275 "././genacc |"
	if (items==1)
          { RETVAL = s->balance; }
        else
          { s->balance = balance; }
#line 1564 "V4l.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Audio_step); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Audio_step)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, step=0");
    {
	Video__Capture__V4l__Audio	s = old_struct (ST(0), "Video::Capture::V4l::Audio");
	U16	step;
	U16	RETVAL;
	dXSTARG;

	if (items < 2)
	    step = 0;
	else {
	    step = (unsigned short)SvUV(ST(1));
	}
#line 287 "././genacc |"
	if (items==1)
          { RETVAL = s->step; }
        else
          { s->step = step; }
#line 1597 "V4l.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Picture_brightness); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Picture_brightness)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, brightness=0");
    {
	Video__Capture__V4l__Picture	s = old_struct (ST(0), "Video::Capture::V4l::Picture");
	U16	brightness;
	U16	RETVAL;
	dXSTARG;

	if (items < 2)
	    brightness = 0;
	else {
	    brightness = (unsigned short)SvUV(ST(1));
	}
#line 302 "././genacc |"
	if (items==1)
          { RETVAL = s->brightness; }
        else
          { s->brightness = brightness; }
#line 1630 "V4l.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Picture_hue); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Picture_hue)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, hue=0");
    {
	Video__Capture__V4l__Picture	s = old_struct (ST(0), "Video::Capture::V4l::Picture");
	U16	hue;
	U16	RETVAL;
	dXSTARG;

	if (items < 2)
	    hue = 0;
	else {
	    hue = (unsigned short)SvUV(ST(1));
	}
#line 314 "././genacc |"
	if (items==1)
          { RETVAL = s->hue; }
        else
          { s->hue = hue; }
#line 1663 "V4l.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Picture_colour); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Picture_colour)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, colour=0");
    {
	Video__Capture__V4l__Picture	s = old_struct (ST(0), "Video::Capture::V4l::Picture");
	U16	colour;
	U16	RETVAL;
	dXSTARG;

	if (items < 2)
	    colour = 0;
	else {
	    colour = (unsigned short)SvUV(ST(1));
	}
#line 326 "././genacc |"
	if (items==1)
          { RETVAL = s->colour; }
        else
          { s->colour = colour; }
#line 1696 "V4l.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Picture_contrast); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Picture_contrast)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, contrast=0");
    {
	Video__Capture__V4l__Picture	s = old_struct (ST(0), "Video::Capture::V4l::Picture");
	U16	contrast;
	U16	RETVAL;
	dXSTARG;

	if (items < 2)
	    contrast = 0;
	else {
	    contrast = (unsigned short)SvUV(ST(1));
	}
#line 338 "././genacc |"
	if (items==1)
          { RETVAL = s->contrast; }
        else
          { s->contrast = contrast; }
#line 1729 "V4l.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Picture_whiteness); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Picture_whiteness)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, whiteness=0");
    {
	Video__Capture__V4l__Picture	s = old_struct (ST(0), "Video::Capture::V4l::Picture");
	U16	whiteness;
	U16	RETVAL;
	dXSTARG;

	if (items < 2)
	    whiteness = 0;
	else {
	    whiteness = (unsigned short)SvUV(ST(1));
	}
#line 350 "././genacc |"
	if (items==1)
          { RETVAL = s->whiteness; }
        else
          { s->whiteness = whiteness; }
#line 1762 "V4l.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Picture_depth); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Picture_depth)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, depth=0");
    {
	Video__Capture__V4l__Picture	s = old_struct (ST(0), "Video::Capture::V4l::Picture");
	U16	depth;
	U16	RETVAL;
	dXSTARG;

	if (items < 2)
	    depth = 0;
	else {
	    depth = (unsigned short)SvUV(ST(1));
	}
#line 362 "././genacc |"
	if (items==1)
          { RETVAL = s->depth; }
        else
          { s->depth = depth; }
#line 1795 "V4l.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Picture_palette); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Picture_palette)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, palette=0");
    {
	Video__Capture__V4l__Picture	s = old_struct (ST(0), "Video::Capture::V4l::Picture");
	U16	palette;
	U16	RETVAL;
	dXSTARG;

	if (items < 2)
	    palette = 0;
	else {
	    palette = (unsigned short)SvUV(ST(1));
	}
#line 374 "././genacc |"
	if (items==1)
          { RETVAL = s->palette; }
        else
          { s->palette = palette; }
#line 1828 "V4l.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Tuner_tuner); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Tuner_tuner)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, tuner=0");
    {
	Video__Capture__V4l__Tuner	s = old_struct (ST(0), "Video::Capture::V4l::Tuner");
	int	tuner;
	int	RETVAL;
	dXSTARG;

	if (items < 2)
	    tuner = 0;
	else {
	    tuner = (int)SvIV(ST(1));
	}
#line 389 "././genacc |"
	if (items==1)
          { RETVAL = s->tuner; }
        else
          { s->tuner = tuner; }
#line 1861 "V4l.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Tuner_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Tuner_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, name=0");
    {
	Video__Capture__V4l__Tuner	s = old_struct (ST(0), "Video::Capture::V4l::Tuner");
	char *	name;
	char *	RETVAL;
	dXSTARG;

	if (items < 2)
	    name = 0;
	else {
	    name = (char *)SvPV_nolen(ST(1));
	}
#line 401 "././genacc |"
	if (items==1)
          { RETVAL = s->name; }
        else
          { croak ("attribute 'name' is readonly"); }
#line 1894 "V4l.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Tuner_rangelow); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Tuner_rangelow)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, rangelow=0");
    {
	Video__Capture__V4l__Tuner	s = old_struct (ST(0), "Video::Capture::V4l::Tuner");
	unsigned long	rangelow;
	unsigned long	RETVAL;
	dXSTARG;

	if (items < 2)
	    rangelow = 0;
	else {
	    rangelow = (unsigned long)SvUV(ST(1));
	}
#line 413 "././genacc |"
	if (items==1)
          { RETVAL = s->rangelow; }
        else
          { croak ("attribute 'rangelow' is readonly"); }
#line 1927 "V4l.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Tuner_rangehigh); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Tuner_rangehigh)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, rangehigh=0");
    {
	Video__Capture__V4l__Tuner	s = old_struct (ST(0), "Video::Capture::V4l::Tuner");
	unsigned long	rangehigh;
	unsigned long	RETVAL;
	dXSTARG;

	if (items < 2)
	    rangehigh = 0;
	else {
	    rangehigh = (unsigned long)SvUV(ST(1));
	}
#line 425 "././genacc |"
	if (items==1)
          { RETVAL = s->rangehigh; }
        else
          { croak ("attribute 'rangehigh' is readonly"); }
#line 1960 "V4l.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Tuner_flags); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Tuner_flags)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, flags=0");
    {
	Video__Capture__V4l__Tuner	s = old_struct (ST(0), "Video::Capture::V4l::Tuner");
	U32	flags;
	U32	RETVAL;
	dXSTARG;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(1));
	}
#line 437 "././genacc |"
	if (items==1)
          { RETVAL = s->flags; }
        else
          { croak ("attribute 'flags' is readonly"); }
#line 1993 "V4l.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Tuner_mode); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Tuner_mode)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, mode=0");
    {
	Video__Capture__V4l__Tuner	s = old_struct (ST(0), "Video::Capture::V4l::Tuner");
	U16	mode;
	U16	RETVAL;
	dXSTARG;

	if (items < 2)
	    mode = 0;
	else {
	    mode = (unsigned short)SvUV(ST(1));
	}
#line 449 "././genacc |"
	if (items==1)
          { RETVAL = s->mode; }
        else
          { s->mode = mode; }
#line 2026 "V4l.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l__Tuner_signal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l__Tuner_signal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "s, signal=0");
    {
	Video__Capture__V4l__Tuner	s = old_struct (ST(0), "Video::Capture::V4l::Tuner");
	U16	signal;
	U16	RETVAL;
	dXSTARG;

	if (items < 2)
	    signal = 0;
	else {
	    signal = (unsigned short)SvUV(ST(1));
	}
#line 461 "././genacc |"
	if (items==1)
          { RETVAL = s->signal; }
        else
          { croak ("attribute 'signal' is readonly"); }
#line 2059 "V4l.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


/* INCLUDE: Returning to 'V4l.xs' from './genacc |' */


XS(XS_Video__Capture__V4l_bgr2rgb); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l_bgr2rgb)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "fr");
    {
	SV *	fr = ST(0);
#line 570 "V4l.xs"
{
        u8 *data, *end;

        end = SvEND (fr);

        for (data = SvPV_nolen (fr); data < end; data += 3)
          {
            data[0] ^= data[2];
            data[2] ^= data[0];
            data[0] ^= data[2];
          }
}
#line 2094 "V4l.c"
	ST(0) = fr;
	SvSETMAGIC(ST(0));
    }
    XSRETURN_EMPTY;
}


XS(XS_Video__Capture__V4l_reduce2); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l_reduce2)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "fr, w");
    {
	SV *	fr = ST(0);
	UI	w = (UI)SvIV(ST(1));
	SV *	RETVAL;
#line 590 "V4l.xs"
{
        u8 *src, *dst, *end;

        src = SvPV_nolen (fr);
        dst = SvPV_nolen (fr);

        w *= 3;

        do
          {
            end = src + w;
            do
              {
                dst[1] = ((UI)src[0] + (UI)src[3]) >> 1; src++;
                dst[2] = ((UI)src[0] + (UI)src[3]) >> 1; src++;
                dst[0] = ((UI)src[0] + (UI)src[3]) >> 1; src++;
                src += 3;
                dst += 3;
              }
            while (src < end);
            src = end + w;
          }
        while (src < (u8*)SvEND (fr));

        SvCUR_set (fr, dst - (u8*)SvPV_nolen (fr));
}
#line 2143 "V4l.c"
	ST(0) = fr;
	SvSETMAGIC(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Video__Capture__V4l_normalize); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l_normalize)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "fr");
    {
	SV *	fr = ST(0);
#line 623 "V4l.xs"
{
        u8 mfr = 255, max = 0;
        u8 *src, *dst, *end;

        end = SvEND (fr);
        dst = SvPV_nolen (fr);

        for (src = SvPV_nolen (fr); src < end; src++)
          {
            if (*src > max) max = *src;
            if (*src < mfr) mfr = *src;
          }

        if (max != mfr)
          for (src = SvPV_nolen (fr); src < end; )
              *dst++ = ((UI)*src++ - mfr) * 255 / (max-mfr);
}
#line 2181 "V4l.c"
	ST(0) = fr;
	SvSETMAGIC(ST(0));
    }
    XSRETURN_EMPTY;
}


XS(XS_Video__Capture__V4l_findmin); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l_findmin)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "db, fr, start=0, count=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	db = ST(0);
	SV *	fr = ST(1);
	UI	start;
	UI	count;

	if (items < 3)
	    start = 0;
	else {
	    start = (UI)SvIV(ST(2));
	}

	if (items < 4)
	    count = 0;
	else {
	    count = (UI)SvIV(ST(3));
	}
#line 650 "V4l.xs"
{
	UI diff, min = -1;
        int mindata, data;
        u8 *src, *dst, *end, *efr;
        UI datasize = SvCUR (fr);
        UI framesize = datasize + sizeof(int);

        src = SvPV_nolen (db) + start * framesize;
        if (src < (u8*)SvPV_nolen (db) || src > (u8*)SvEND (db))
          src = SvPV_nolen (db);

        end = src + count * framesize;
        if (end <= src || end > (u8*)SvEND (db))
          end = SvEND (db);

        do
          {
            data = *((int *)src); src += sizeof (int);

            dst = SvPV_nolen (fr);
            efr = src + datasize;
            diff = 0;

            do
              {
                int dif = (int)*src++ - (int)*dst++;
                diff += dif*dif;
              }
            while (src < efr);

            if (min > diff)
              {
                min = diff;
                mindata = data;
              }
          }
        while (src < end);

        EXTEND (sp, 2);
        PUSHs (sv_2mortal (newSViv (mindata)));
        PUSHs (sv_2mortal (newSViv ((min << 8) / SvCUR (fr))));
}
#line 2261 "V4l.c"
	PUTBACK;
	return;
    }
}


XS(XS_Video__Capture__V4l_linreg); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l_linreg)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "array");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	array = ST(0);
#line 697 "V4l.xs"
{
	AV *xy = (AV*) SvRV (array);
	I32 i;
	I32 n = (av_len (xy)+1)>>1;
        double x_ = 0, y_ = 0;
        double sxy = 0, sxx = 0, syy = 0;

	for (i=0; i<n; i++)
          {
            x_ += SvNV(*av_fetch(xy, i*2  ,1));
            y_ += SvNV(*av_fetch(xy, i*2+1,1));
          }

        x_ /= n;
        y_ /= n;

	for (i=0; i<n; i++)
          {
            double x = SvNV(*av_fetch(xy, i*2  ,1));
            double y = SvNV(*av_fetch(xy, i*2+1,1));

            sxy += (x-x_)*(y-y_);
            sxx += (x-x_)*(x-x_);
            syy += (y-y_)*(y-y_);
          }

        {
          double rxy2 = sxy*sxy / (sxx*syy);
          double b = sxy / sxx;
          double a = y_ - b*x_;
          double r2 = (n-1)/(n-2)*syy*(1-rxy2);

          EXTEND (sp, 3);
          PUSHs (sv_2mortal (newSVnv (a )));
          PUSHs (sv_2mortal (newSVnv (b )));
          PUSHs (sv_2mortal (newSVnv (r2)));
        }
}
#line 2321 "V4l.c"
	PUTBACK;
	return;
    }
}


XS(XS_Video__Capture__V4l_linreg1); /* prototype to pass -Wmissing-prototypes */
XS(XS_Video__Capture__V4l_linreg1)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "array");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	array = ST(0);
#line 740 "V4l.xs"
{
	AV *xy = (AV*) SvRV (array);
	I32 i;
	I32 n = (av_len (xy)+1)>>1;
        double c = 0;
        double c2 = 0;

	for (i=0; i<n; i++)
          {
            double d = SvNV(*av_fetch(xy, i*2-1,1)) - SvNV(*av_fetch(xy, i*2,1));
            c += d;
          }

        c /= n;

	for (i=0; i<n; i++)
          {
            double d = c + SvNV(*av_fetch(xy, i*2,1)) - SvNV(*av_fetch(xy, i*2-1,1));
            c2 += d*d;
          }

        c2 /= n;

        EXTEND (sp, 3);
        PUSHs (sv_2mortal (newSVnv (c)));
        PUSHs (sv_2mortal (newSVnv (1)));
        PUSHs (sv_2mortal (newSVnv (c2)));
}
#line 2371 "V4l.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Video__Capture__V4l); /* prototype to pass -Wmissing-prototypes */
XS(boot_Video__Capture__V4l)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        (void)newXSproto_portable("Video::Capture::V4l::VBI::field", XS_Video__Capture__V4l__VBI_field, file, "$");
        (void)newXSproto_portable("Video::Capture::V4l::VBI::backlog", XS_Video__Capture__V4l__VBI_backlog, file, "$$");
        (void)newXSproto_portable("Video::Capture::V4l::VBI::queued", XS_Video__Capture__V4l__VBI_queued, file, "$");
        (void)newXSproto_portable("Video::Capture::V4l::capture", XS_Video__Capture__V4l_capture, file, "$$$$;$");
        (void)newXSproto_portable("Video::Capture::V4l::sync", XS_Video__Capture__V4l_sync, file, "$$");
        (void)newXSproto_portable("Video::Capture::V4l::_freq", XS_Video__Capture__V4l__freq, file, "$$");
        (void)newXSproto_portable("Video::Capture::V4l::_capabilities_new", XS_Video__Capture__V4l__capabilities_new, file, "$");
        (void)newXSproto_portable("Video::Capture::V4l::_channel_new", XS_Video__Capture__V4l__channel_new, file, "$");
        (void)newXSproto_portable("Video::Capture::V4l::_tuner_new", XS_Video__Capture__V4l__tuner_new, file, "$");
        (void)newXSproto_portable("Video::Capture::V4l::_audio_new", XS_Video__Capture__V4l__audio_new, file, "$");
        (void)newXSproto_portable("Video::Capture::V4l::_picture_new", XS_Video__Capture__V4l__picture_new, file, "$");
        (void)newXSproto_portable("Video::Capture::V4l::Capability::get", XS_Video__Capture__V4l__Capability_get, file, "$");
        (void)newXSproto_portable("Video::Capture::V4l::Channel::get", XS_Video__Capture__V4l__Channel_get, file, "$");
        (void)newXSproto_portable("Video::Capture::V4l::Channel::set", XS_Video__Capture__V4l__Channel_set, file, "$");
        (void)newXSproto_portable("Video::Capture::V4l::Tuner::get", XS_Video__Capture__V4l__Tuner_get, file, "$");
        (void)newXSproto_portable("Video::Capture::V4l::Tuner::set", XS_Video__Capture__V4l__Tuner_set, file, "$");
        (void)newXSproto_portable("Video::Capture::V4l::Audio::get", XS_Video__Capture__V4l__Audio_get, file, "$");
        (void)newXSproto_portable("Video::Capture::V4l::Audio::set", XS_Video__Capture__V4l__Audio_set, file, "$");
        (void)newXSproto_portable("Video::Capture::V4l::Picture::get", XS_Video__Capture__V4l__Picture_get, file, "$");
        (void)newXSproto_portable("Video::Capture::V4l::Picture::set", XS_Video__Capture__V4l__Picture_set, file, "$");
        (void)newXS("Video::Capture::V4l::Capability::name", XS_Video__Capture__V4l__Capability_name, file);
        (void)newXS("Video::Capture::V4l::Capability::type", XS_Video__Capture__V4l__Capability_type, file);
        (void)newXS("Video::Capture::V4l::Capability::channels", XS_Video__Capture__V4l__Capability_channels, file);
        (void)newXS("Video::Capture::V4l::Capability::audios", XS_Video__Capture__V4l__Capability_audios, file);
        (void)newXS("Video::Capture::V4l::Capability::maxwidth", XS_Video__Capture__V4l__Capability_maxwidth, file);
        (void)newXS("Video::Capture::V4l::Capability::maxheight", XS_Video__Capture__V4l__Capability_maxheight, file);
        (void)newXS("Video::Capture::V4l::Capability::minwidth", XS_Video__Capture__V4l__Capability_minwidth, file);
        (void)newXS("Video::Capture::V4l::Capability::minheight", XS_Video__Capture__V4l__Capability_minheight, file);
        (void)newXS("Video::Capture::V4l::Channel::channel", XS_Video__Capture__V4l__Channel_channel, file);
        (void)newXS("Video::Capture::V4l::Channel::name", XS_Video__Capture__V4l__Channel_name, file);
        (void)newXS("Video::Capture::V4l::Channel::tuners", XS_Video__Capture__V4l__Channel_tuners, file);
        (void)newXS("Video::Capture::V4l::Channel::flags", XS_Video__Capture__V4l__Channel_flags, file);
        (void)newXS("Video::Capture::V4l::Channel::type", XS_Video__Capture__V4l__Channel_type, file);
        (void)newXS("Video::Capture::V4l::Channel::norm", XS_Video__Capture__V4l__Channel_norm, file);
        (void)newXS("Video::Capture::V4l::Audio::audio", XS_Video__Capture__V4l__Audio_audio, file);
        (void)newXS("Video::Capture::V4l::Audio::volume", XS_Video__Capture__V4l__Audio_volume, file);
        (void)newXS("Video::Capture::V4l::Audio::bass", XS_Video__Capture__V4l__Audio_bass, file);
        (void)newXS("Video::Capture::V4l::Audio::treble", XS_Video__Capture__V4l__Audio_treble, file);
        (void)newXS("Video::Capture::V4l::Audio::flags", XS_Video__Capture__V4l__Audio_flags, file);
        (void)newXS("Video::Capture::V4l::Audio::name", XS_Video__Capture__V4l__Audio_name, file);
        (void)newXS("Video::Capture::V4l::Audio::mode", XS_Video__Capture__V4l__Audio_mode, file);
        (void)newXS("Video::Capture::V4l::Audio::balance", XS_Video__Capture__V4l__Audio_balance, file);
        (void)newXS("Video::Capture::V4l::Audio::step", XS_Video__Capture__V4l__Audio_step, file);
        (void)newXS("Video::Capture::V4l::Picture::brightness", XS_Video__Capture__V4l__Picture_brightness, file);
        (void)newXS("Video::Capture::V4l::Picture::hue", XS_Video__Capture__V4l__Picture_hue, file);
        (void)newXS("Video::Capture::V4l::Picture::colour", XS_Video__Capture__V4l__Picture_colour, file);
        (void)newXS("Video::Capture::V4l::Picture::contrast", XS_Video__Capture__V4l__Picture_contrast, file);
        (void)newXS("Video::Capture::V4l::Picture::whiteness", XS_Video__Capture__V4l__Picture_whiteness, file);
        (void)newXS("Video::Capture::V4l::Picture::depth", XS_Video__Capture__V4l__Picture_depth, file);
        (void)newXS("Video::Capture::V4l::Picture::palette", XS_Video__Capture__V4l__Picture_palette, file);
        (void)newXS("Video::Capture::V4l::Tuner::tuner", XS_Video__Capture__V4l__Tuner_tuner, file);
        (void)newXS("Video::Capture::V4l::Tuner::name", XS_Video__Capture__V4l__Tuner_name, file);
        (void)newXS("Video::Capture::V4l::Tuner::rangelow", XS_Video__Capture__V4l__Tuner_rangelow, file);
        (void)newXS("Video::Capture::V4l::Tuner::rangehigh", XS_Video__Capture__V4l__Tuner_rangehigh, file);
        (void)newXS("Video::Capture::V4l::Tuner::flags", XS_Video__Capture__V4l__Tuner_flags, file);
        (void)newXS("Video::Capture::V4l::Tuner::mode", XS_Video__Capture__V4l__Tuner_mode, file);
        (void)newXS("Video::Capture::V4l::Tuner::signal", XS_Video__Capture__V4l__Tuner_signal, file);
        (void)newXSproto_portable("Video::Capture::V4l::bgr2rgb", XS_Video__Capture__V4l_bgr2rgb, file, "$");
        (void)newXSproto_portable("Video::Capture::V4l::reduce2", XS_Video__Capture__V4l_reduce2, file, "$$");
        (void)newXSproto_portable("Video::Capture::V4l::normalize", XS_Video__Capture__V4l_normalize, file, "$");
        (void)newXSproto_portable("Video::Capture::V4l::findmin", XS_Video__Capture__V4l_findmin, file, "$$;$$");
        (void)newXSproto_portable("Video::Capture::V4l::linreg", XS_Video__Capture__V4l_linreg, file, "$");
        (void)newXSproto_portable("Video::Capture::V4l::linreg1", XS_Video__Capture__V4l_linreg1, file, "$");

    /* Initialisation Section */

#line 505 "V4l.xs"
{
	HV *stash = gv_stashpvn("Video::Capture::V4l", 19, TRUE);

	newCONSTSUB(stash,"AUDIO_BASS",	newSViv(VIDEO_AUDIO_BASS));
	newCONSTSUB(stash,"AUDIO_MUTABLE",	newSViv(VIDEO_AUDIO_MUTABLE));
	newCONSTSUB(stash,"AUDIO_MUTE",	newSViv(VIDEO_AUDIO_MUTE));
	newCONSTSUB(stash,"AUDIO_TREBLE",	newSViv(VIDEO_AUDIO_TREBLE));
	newCONSTSUB(stash,"AUDIO_VOLUME",	newSViv(VIDEO_AUDIO_VOLUME));
	newCONSTSUB(stash,"CAPTURE_EVEN",	newSViv(VIDEO_CAPTURE_EVEN));
	newCONSTSUB(stash,"CAPTURE_ODD",	newSViv(VIDEO_CAPTURE_ODD));
	newCONSTSUB(stash,"MAX_FRAME",	newSViv(VIDEO_MAX_FRAME));
	newCONSTSUB(stash,"MODE_AUTO",	newSViv(VIDEO_MODE_AUTO));
	newCONSTSUB(stash,"MODE_NTSC",	newSViv(VIDEO_MODE_NTSC));
	newCONSTSUB(stash,"MODE_PAL",	newSViv(VIDEO_MODE_PAL));
	newCONSTSUB(stash,"MODE_SECAM",	newSViv(VIDEO_MODE_SECAM));
	newCONSTSUB(stash,"PALETTE_COMPONENT",	newSViv(VIDEO_PALETTE_COMPONENT));
	newCONSTSUB(stash,"PALETTE_GREY",	newSViv(VIDEO_PALETTE_GREY));
	newCONSTSUB(stash,"PALETTE_HI240",	newSViv(VIDEO_PALETTE_HI240));
	newCONSTSUB(stash,"PALETTE_PLANAR",	newSViv(VIDEO_PALETTE_PLANAR));
	newCONSTSUB(stash,"PALETTE_RAW",	newSViv(VIDEO_PALETTE_RAW));
	newCONSTSUB(stash,"PALETTE_RGB24",	newSViv(VIDEO_PALETTE_RGB24));
	newCONSTSUB(stash,"PALETTE_RGB32",	newSViv(VIDEO_PALETTE_RGB32));
	newCONSTSUB(stash,"PALETTE_RGB555",	newSViv(VIDEO_PALETTE_RGB555));
	newCONSTSUB(stash,"PALETTE_RGB565",	newSViv(VIDEO_PALETTE_RGB565));
	newCONSTSUB(stash,"PALETTE_UYVY",	newSViv(VIDEO_PALETTE_UYVY));
	newCONSTSUB(stash,"PALETTE_YUV410P",	newSViv(VIDEO_PALETTE_YUV410P));
	newCONSTSUB(stash,"PALETTE_YUV411",	newSViv(VIDEO_PALETTE_YUV411));
	newCONSTSUB(stash,"PALETTE_YUV411P",	newSViv(VIDEO_PALETTE_YUV411P));
	newCONSTSUB(stash,"PALETTE_YUV420",	newSViv(VIDEO_PALETTE_YUV420));
	newCONSTSUB(stash,"PALETTE_YUV420P",	newSViv(VIDEO_PALETTE_YUV420P));
	newCONSTSUB(stash,"PALETTE_YUV422",	newSViv(VIDEO_PALETTE_YUV422));
	newCONSTSUB(stash,"PALETTE_YUV422P",	newSViv(VIDEO_PALETTE_YUV422P));
	newCONSTSUB(stash,"PALETTE_YUYV",	newSViv(VIDEO_PALETTE_YUYV));
	newCONSTSUB(stash,"SOUND_LANG1",	newSViv(VIDEO_SOUND_LANG1));
	newCONSTSUB(stash,"SOUND_LANG2",	newSViv(VIDEO_SOUND_LANG2));
	newCONSTSUB(stash,"SOUND_MONO",	newSViv(VIDEO_SOUND_MONO));
	newCONSTSUB(stash,"SOUND_STEREO",	newSViv(VIDEO_SOUND_STEREO));
	newCONSTSUB(stash,"TUNER_LOW",	newSViv(VIDEO_TUNER_LOW));
	newCONSTSUB(stash,"TUNER_MBS_ON",	newSViv(VIDEO_TUNER_MBS_ON));
	newCONSTSUB(stash,"TUNER_NORM",	newSViv(VIDEO_TUNER_NORM));
	newCONSTSUB(stash,"TUNER_NTSC",	newSViv(VIDEO_TUNER_NTSC));
	newCONSTSUB(stash,"TUNER_PAL",	newSViv(VIDEO_TUNER_PAL));
	newCONSTSUB(stash,"TUNER_RDS_ON",	newSViv(VIDEO_TUNER_RDS_ON));
	newCONSTSUB(stash,"TUNER_SECAM",	newSViv(VIDEO_TUNER_SECAM));
	newCONSTSUB(stash,"TUNER_STEREO_ON",	newSViv(VIDEO_TUNER_STEREO_ON));
	newCONSTSUB(stash,"TYPE_CAMERA",	newSViv(VIDEO_TYPE_CAMERA));
	newCONSTSUB(stash,"TYPE_TV",	newSViv(VIDEO_TYPE_TV));
	newCONSTSUB(stash,"VC_AUDIO",	newSViv(VIDEO_VC_AUDIO));
	newCONSTSUB(stash,"VC_TUNER",	newSViv(VIDEO_VC_TUNER));
	newCONSTSUB(stash,"TYPE_CAPTURE",	newSViv(VID_TYPE_CAPTURE));
	newCONSTSUB(stash,"TYPE_CHROMAKEY",	newSViv(VID_TYPE_CHROMAKEY));
	newCONSTSUB(stash,"TYPE_CLIPPING",	newSViv(VID_TYPE_CLIPPING));
	newCONSTSUB(stash,"TYPE_FRAMERAM",	newSViv(VID_TYPE_FRAMERAM));
	newCONSTSUB(stash,"TYPE_MONOCHROME",	newSViv(VID_TYPE_MONOCHROME));
	newCONSTSUB(stash,"TYPE_OVERLAY",	newSViv(VID_TYPE_OVERLAY));
	newCONSTSUB(stash,"TYPE_SCALES",	newSViv(VID_TYPE_SCALES));
	newCONSTSUB(stash,"TYPE_SUBCAPTURE",	newSViv(VID_TYPE_SUBCAPTURE));
	newCONSTSUB(stash,"TYPE_TELETEXT",	newSViv(VID_TYPE_TELETEXT));
	newCONSTSUB(stash,"TYPE_TUNER",	newSViv(VID_TYPE_TUNER));
}

#line 2526 "V4l.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

